stages:
  - validate
  - plan
  - apply

image: 
  name: hashicorp/terraform
  entrypoint:
    - '/usr/bin/env'
    - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'

variables:
  PLAN: plan.tfplan

before_script:
  - terraform --version
  - terraform init

validate:
  stage: validate
  script:
    - terraform validate

plan:
  stage: plan
  script:
    - terraform plan -out=$PLAN
  artifacts:
    paths:
      - $PLAN

apply:
  stage: apply
  script:
    - terraform apply $PLAN
  when: manual